%% dx7

%% triplet setup

clear;
global cv th rn dn;
cv = [ 0 0 0 0 0 0 0 0];
%th = [ 0 0 0 0 0 0 0 0];
th = [ 0 2 0 1 0 3 0 0];
sk16 = [1.617271 1.622861 1.627559];
f4 = [1.611644 1.620578 1.628484];
bk7 = [1.514322 1.51680 1.522376];
rn = [ 1 sk16(2) 1 f4(2) 1 bk7(2) 1 1];
dn = [ 0 sk16(3)-sk16(1) 0 f4(3)-f4(1) 0 bk7(3)-bk7(1) 0 0];
sa = [0 6.5 6.5 6.5  0 6.5 6.5 6.5 0];
lp = find(rn>1);
as = 5;

v = [1/50 -2/50]';

%% trip1 code

cv(2:3)=lens_shape(v(1),1,rn(2)); % shape 1 (convex-plano)
cv(4:5)=lens_shape(v(2),0,rn(4)); % shape 2 (equi-concave)
cv(6)=0;
yap = 50/8;
uco = tan(2.0*pi/180);
scl = yap^2/2;
ya = parax([yap 0],cv,th,rn);
usolve = -0.125;
yn=ya(7,1);
% paraxial height solve for image distance
th(7) = -yn/usolve;
ya(8,1) = 0;
% paraxial angle solve for power
if (abs(yn)>1e-6)
    cv(7)= -(rn(7)*usolve-rn(6)*ya(6,2))/((rn(7)-rn(6))*yn);
end
ya(7,2)=usolve;


show_lens
drawsys

%%
th(3)=5;
th(5)=7;
trip1(v);
show_lens
drawsys

%%

[f v]=trip3;
%[xo vout hp]=cycle(v,@trip3);
%[A fz] = calculate_derivatives(@trip3,xo);
[A fz] = calculate_derivatives(@trip3,v);
[U W V] = svd(A,0);
d = diag(W);
n = length(d);
sing = 1e-8;
semilogy(1:n,d,'ko',0,1);
%semilogy(1:n,d,'ko',[0 n],sing*max(d)*[1 1],'b--');
ylabel('eigenvalues');
fprintf('eigenvalues: min %g max %g\n',min(d),max(d));

%%

Va  = abs(V);
totals = sum(Va);
size(Va)
size(totals)
Vn = Va./(ones(size(totals))'*totals);
% variable names
vname = cellstr(['cv2'; 'cv3'; 'cv4'; 'cv5'; 'cv6'; 'cv7'; 'th3'; 'th5']);
for k=1:8
    str = char(vname(k));
    fprintf('%3s %6.1f %6.1f %6.1f %6.1f %6.1f %6.1f %6.1f %6.1f\n',str,100*Vn(:,k));
end
imwrite(imresize(Vn,16,'nearest'),'html/dx7.jpg');

%%
% This image shows the above array
%
% <<dx7.jpg>>
% 

%% optimize

[xo vout hp] = cycle(v,@trip3);

%%

show_lens

%% optimization progress plot


sigma = hp(:,1);
damp = hp(:,2);

n = length(sigma);
k = (1:n)-1;
subplot(2,1,1);
if n<20
%plot(k,log10(sigma),'ko-','LineWidth',2);
    semilogy(k,sigma,'ko-','LineWidth',2);
else
    semilogy(k,sigma,'k','LineWidth',2);
end
grid;
xlabel('iteration');
ylabel('merit value');
subplot(2,1,2);
if n<20
    plot(k(2:n),damp(2:n),'ko-',0,1.1,'LineWidth',2);
else
    plot(k(2:n),damp(2:n),'k',0,1.1,'LineWidth',2);
end
grid;
xlabel('iteration');
ylabel('damping');

%% final design

subplot(1,1,1)
drawsys

%% show steps

sz = size(vout);
disp(sz)
for k=1:8
    str = sprintf('iteration %d',k);
    v = vout(k,:);
    trip3(v);
    subplot(2,4,k);
    drawsys;
    axis([0 25 -8 8]);
    title(str);
end






