%% show lens

yap = 50/8;
uco = tan(2.0*pi/180);
scl = yap^2/2;
lambda = 0.58756e-3;


ya = parax([yap 0],cv,th,rn);

% set chief ray to zero at stop

yco = 0;
yc = parax([yco uco],cv,th,rn);
yn=ya(as,1);
if (abs(yn)>1e-6)
    ks = -yc(as,1)/ya(as,1);
    yc = yc + ks*ya;
    yco = yc(2,1);
end

n = length(th);
% show system
fprintf('\nsystem prescription\n\n');
fprintf('%2s %12s %12s %12s\n','sn','rd','th','rn');
rd = curvature(cv);
for k=1:n
    str = sprintf('%2d',k-1);
    if k==as
        str = 'as';
    end
    fprintf('%2s %12.5f %12.5f %12.5f\n',str,rd(k),th(k),rn(k));
end

% show paraxial raytrace
fprintf('\nparaxial raytrace\n\n');
fprintf('%2s %12s %12s %12s %12s %12s\n','sn','ya','ua','yc','uc','clap');
for k=1:n
    clap = abs(ya(k,1))+abs(yc(k,1));
    fprintf('%2d %12.5f %12.5f %12.5f %12.5f %12.5f\n',k-1,ya(k,:),yc(k,:),clap);
end
% power
power = -ya(7,2)/ya(1,1);
perror = scl*(power - 1/50); % power error
if abs(perror)>1e-10
    fprintf('efl %g\n',1/power);
end
ford(ya,yc,cv,th,rn,1);
[w wsurf petz] = ford(ya,yc,cv,th,rn,lambda);
fprintf('\n%12s %12s %12s %12s %12s %12s\n','W040','W131','W222','W220','W311','W220P');
fprintf('%12.2f %12.2f %12.2f %12.2f %12.2f %12.2f\n',w,petz*scl)
wv = chromatic(ya,yc,cv,th,rn,dn,lambda);

fprintf('\nChromatic Aberrations\n');
fprintf('\n%12s %12s\n','axial','lateral');
fprintf('%12.2f %12.2f\n',wv);
